var tim;
let promise;

	function imchart(SDKAppID, groupID, userID, userSig) {
		var options = {
			SDKAppID: SDKAppID // 接入时需要将0替换为您的即时通信 IM 应用的 SDKAppID
		};
		// 创建 SDK 实例，`TIM.create()`方法对于同一个 `SDKAppID` 只会返回同一份实例
		tim = TIM.create(options);
		// 设置 SDK 日志输出级别，详细分级请参见 setLogLevel 接口的说明
		tim.setLogLevel(4); // 普通级别，日志量较多，接入时建议使用
		// tim.setLogLevel(1); // release 级别，SDK 输出关键信息，生产环境时建议使用

		// 注册 COS SDK 插件
		tim.registerPlugin({
			'cos-js-sdk': 'cos-js-sdk-v5.min.js'
		});

		tim.on(TIM.EVENT.MESSAGE_RECEIVED, function(event) {
			console.log(JSON.stringify(event));
			switch (event.data[0].type) {
				case 'TIMGroupTipElem':
					TIMGroupTipElem(event);
					break;
				case 'TIMTextElem':
					HDinnerHTML(event.data);
					break;
				default:
					break;  
			}

			function TIMGroupTipElem(event) {
				switch (event.data[0].payload.operationType) {
					case 6:
						// document.getElementById('zidingcontent').innerText = event.data[0].payload.newGroupProfile.introduction;
						break;
					default:
						break;
				}
			}

		});

		tim.on(TIM.EVENT.MESSAGE_REVOKED, function(event) {
			console.log(event)
			// 收到消息被撤回的通知
			// event.name - TIM.EVENT.MESSAGE_REVOKED
			// event.data - 存储 Message 对象的数组 - [Message] - 每个 Message 对象的 isRevoked 属性值为 true
		});

		tim.on(TIM.EVENT.CONVERSATION_LIST_UPDATED, function(event) {
			console.log(JSON.stringify(event))
			// 收到会话列表更新通知，可通过遍历 event.data 获取会话列表数据并渲染到页面
			// event.name - TIM.EVENT.CONVERSATION_LIST_UPDATED
			// event.data - 存储 Conversation 对象的数组 - [Conversation]
		});

		tim.on(TIM.EVENT.GROUP_LIST_UPDATED, function(event) {
			console.log(JSON.stringify(event))
			// 收到群组列表更新通知，可通过遍历 event.data 获取群组列表数据并渲染到页面
			// event.name - TIM.EVENT.GROUP_LIST_UPDATED
			// event.data - 存储 Group 对象的数组 - [Group]
		});

		tim.on(TIM.EVENT.GROUP_SYSTEM_NOTICE_RECEIVED, function(event) {
			console.log(event)
			// 收到新的群系统通知
			// event.name - TIM.EVENT.GROUP_SYSTEM_NOTICE_RECEIVED
			// event.data.type - 群系统通知的类型，详情请参见 GroupSystemNoticePayload 的 operationType 枚举值说明
			// event.data.message - Message 对象，可将 event.data.message.content 渲染到到页面
		});

		tim.on(TIM.EVENT.PROFILE_UPDATED, function(event) {
			console.log(event)
			// 收到自己或好友的资料变更通知
			// event.name - TIM.EVENT.PROFILE_UPDATED
			// event.data - 存储 Profile 对象的数组 - [Profile]
		});

		tim.on(TIM.EVENT.BLACKLIST_UPDATED, function(event) {
			console.log(event)
			// 收到黑名单列表更新通知
			// event.name - TIM.EVENT.BLACKLIST_UPDATED
			// event.data - 存储 userID 的数组 - [userID]
		});

		tim.on(TIM.EVENT.ERROR, function(event) {
			console.log(JSON.stringify(event))
			// 收到 SDK 发生错误通知，可以获取错误码和错误信息
			// event.name - TIM.EVENT.ERROR
			// event.data.code - 错误码
			// event.data.message - 错误信息
		});

		tim.on(TIM.EVENT.SDK_NOT_READY, function(event) {
			console.log(event)
			// 收到 SDK 进入 not ready 状态通知，此时 SDK 无法正常工作
			// event.name - TIM.EVENT.SDK_NOT_READY
		});

		tim.on(TIM.EVENT.KICKED_OUT, function(event) {
			console.log(event)
			// 收到被踢下线通知
			// event.name - TIM.EVENT.KICKED_OUT
			// event.data.type - 被踢下线的原因，例如:
			//    - TIM.TYPES.KICKED_OUT_MULT_ACCOUNT 多实例登录被踢
			//    - TIM.TYPES.KICKED_OUT_MULT_DEVICE 多终端登录被踢
			//    - TIM.TYPES.KICKED_OUT_USERSIG_EXPIRED 签名过期被踢
		});

		//登录
		/* let promise = tim.login({
			userID: '123456',
			userSig: 'eJwtzMsKwjAURdF-yVjqzaMxLTjR0oEIDlQwzpTEeqmWmAQfiP9uaDs8a8P5kt16mz2tJyVhGZBJv9HYLuIFe6aMi1yOJZj25BwaUlIBwJkCIYYS8W6T5opLRVMY1L4d*uQShAIYP7BJtxuru8X5uFeULYHRWxHDtHhdw4FqX*u4Uh*sZFU-mlk7J78-VR4vow__'
		}); */
		/* let promise = tim.login({
			userID: 'user1',
			userSig: 'eJyrVgrxCdYrSy1SslIy0jNQ0gHzM1NS80oy0zLBwqXFqUWGUInilOzEgoLMFCUrQxMDA2MjCwMTE4hMakVBZlEqUNzU1NTIwMAAIlqSmQsWszAxsDC0hKktzkwHmmtcHBKWVFDhFVGmHZFR7GbhlR2jbxiYEuRfmZ4XXuFUYJiX4VngVlBlEJSYbatUCwBY-TJR'
		}); */
		/* let promise = tim.login({
			userID: 'user2',
			userSig: 'eJwtzF0LgjAYhuH-suOwd2viFDrqgwjtxEKIToxNewlrORez6L8n08PneuD*kmOaB2-VkoSwAMjMb5Tq0WGFnq1RLZsOI**l1ihJQjnAggngfHyU09iqwcMwZAAwaoeNN8FBUBGzqYL10F1lRuJlvllLeji9bjYqolzHme7t1vXnvbumzQfL*lnsKr4kvz9YzjKJ'
		}); */
		promise = tim.login({
			userID: userID,
			userSig: userSig
		});
		promise.then(function(imResponse) {
			console.log(imResponse.data); // 登录成功
		}).catch(function(imError) {
			console.warn('login error:', imError); // 登录失败的相关信息
		});

		tim.on(TIM.EVENT.SDK_READY, function(event) {
			console.log(event);

			tim.joinGroup({
				groupID: groupID,
				type: TIM.TYPES.GRP_AVCHATROOM
			});

			//获取群消息
			tim.getGroupProfile({
				groupID: groupID
			}).then(function(imResponse) {
				console.log(imResponse);
				// document.getElementById('zidingcontent').innerText = imResponse.data.group.introduction;
			}).catch(function(imError) {
				console.warn('getGroupProfile error:', imError); // 获取群详细资料失败的相关信息
			});

			//修改群组资料
			/* tim.updateGroupProfile({
				groupID: '1234567',
				introduction: '1、d置顶的内容bb 2、置顶内容b', // 修改群公告
			}).then(function(imResponse) {
				console.log(imResponse) // 修改成功后的群组详细资料
			}).catch(function(imError) {
				console.warn('updateGroupProfile error:', imError); // 修改群组资料失败的相关信息
			}); */

		});

	}
