/**
 * 版本号目前使用到的参数描述
 * 
 * AppDomain： app下载地址域名+路径前缀
 * IsAshenStyle： 灰度显示  0为正常显示 1为灰度显示
 * 
 * MainAndroidServerVersion： 安卓大版本号（安装包更新）
 * AndroidServerFlag： 安卓强制更新控制 0强制更新 1不强制更新 
 * AndroidServerFlagSilent： 安卓非问询更新控制 0非问询更新 1不非问询更新 2问询是否重启（无取消按钮） 3问询是否重启(有取消按钮)
 * BranchAndroidServerVersion： 安卓小版本号 表示安卓的小版本号（增量更新更新）
 * MainAndroidUpdateurl： 安卓大版本（apk）下载路径
 * BranchAndroidUpdateurl： 安卓小版本（wgt）下载路径
 * 
 * IosServerFlag： IOS大版本号 表示ios需要强制更新的大版本号（Appstore更新）
 * StoreBranchIosServerVersion： IOS小版本号 表示ios的小版本号（增量更新更新）
 * IosServerFlagSilent：IOS非问询更新控制 0非问询更新 1不非问询更新 2问询是否重启
 * IosServerFlagBranch： IOS强制更新控制 0强制更新 1不强制更新 
 * StoreBranchIosUpdateurl： IOS小版本（wgt）下载路径
 * 
 */


//更新描述文件
var updateres = {};
// 下载wgt文件  
var wgtUrl = "";

var serverFlagSilent = '0' //非问询更新参数

//unShow 是否弹出更新提示框
function update(unShow) {

	mui.plusReady(function() {

		var baseUrl = "https://gbpx.gd.gov.cn/app/appDownload/"

		plus.runtime.getProperty(plus.runtime.appid, function(inf) {
			curVer = inf.version;
			api.personal.getNewAppVersion({
					IsVersion: true
				}, function(res) {

					if (res.AppDomain) {
						baseUrl = res.AppDomain;
					}

					console.log("updataRes = " + JSON.stringify(res));
					updateres.Data = res

					if (unShow === true) {
						return;
					}
					try {
						setTimeout(function() {
							const page0 = plus.webview.getLaunchWebview()
							const page1 = plus.webview.getWebviewById(
								'learn/index.html?tab=homepage');
							const page2 = plus.webview.getWebviewById(
								'liveBroadcast/index.html?tab=liveBroadcast');
							const page3 = plus.webview.getWebviewById(
								'specialClass/index.html?tab=specialClass');
							const page4 = plus.webview.getWebviewById(
								'zhongyuanwang/index.html?tab=zhongyuanwang');
							const page5 = plus.webview.getWebviewById(
								'my/index.html?tab=my');
							const pageArr = [page0, page1, page2, page3, page4, page5]
							pageArr.forEach(e => mui.fire(e, 'changeAshenStyle', {
								isAshenStyle: updateres.Data.IsAshenStyle
							}))
							localStorage.setItem('isAshenStyle', updateres.Data
								.IsAshenStyle)
						}, 1500);
					} catch (e) {}


					switch (plus.os.name) {
						case "Android":
							serverFlagSilent = updateres.Data.AndroidServerFlagSilent;
							if (compareVersion(curVer, updateres.Data.MainAndroidServerVersion)) {

								if (updateres.Data.AndroidServerFlag == '0') {
									//强制更新
									wgtUrl = baseUrl + updateres.Data
										.MainAndroidUpdateurl;
									alertUpdata(wgtUrl);
								} else {
									mui.confirm('检测到有新版本，为了不影响您的正常使用，请更新至新版本', '更新提示', ['暂不更新',
											'立即更新'
										],
										function(e) {
											if (e.index === 1) {
												wgtUrl = baseUrl + updateres.Data
													.MainAndroidUpdateurl;
												isConnectUrl(wgtUrl);
											} else {
												sessionStorage.setItem('isUpdate', 'true');
											}
										})
								}
							} else
							if (compareVersion(curVer, updateres.Data.BranchAndroidServerVersion)) {
								//增量更新
								if (updateres.Data.AndroidServerFlagSilent != '1') {
									//强制更新
									wgtUrl = baseUrl + updateres.Data
										.BranchAndroidUpdateurl;
									isConnectUrl(wgtUrl, true);

								} else if (updateres.Data.AndroidServerFlag == '0') {
									//强制更新
									wgtUrl = baseUrl + updateres.Data
										.BranchAndroidUpdateurl;
									alertUpdata(wgtUrl);

								} else {
									mui.confirm('检测到有新版本，为了不影响您的正常使用，请更新至新版本', '更新提示', ['暂不更新',
											'立即更新'
										],
										function(e) {
											if (e.index === 1) {
												wgtUrl = baseUrl + updateres.Data
													.BranchAndroidUpdateurl;
												isConnectUrl(wgtUrl);
											} else {
												sessionStorage.setItem('isUpdate', 'true');
											}
										})
								}

							}

							break;
						case "iOS":

							serverFlagSilent = updateres.Data.IosServerFlagSilent;
							if (compareVersion(curVer, updateres.Data.IosServerFlag)) {
								//强制更新
								alertUpdataAppstore();
							} else
							if (compareVersion(curVer, updateres.Data
									.StoreBranchIosServerVersion)) {

								if (updateres.Data.IosServerFlagSilent != '1') {
									//非问询更新
									wgtUrl = baseUrl + updateres.Data
										.StoreBranchIosUpdateurl;
									isConnectUrl(wgtUrl, true);
								} else if (updateres.Data.IosServerFlagBranch != undefined &&
									updateres
									.Data.IosServerFlagBranch == '0') {
									//强制更新
									mui.alert('检测到有新版本，为了不影响您的正常使用，请更新至新版本', '更新提示',
										function(e) {

											wgtUrl = baseUrl + updateres.Data
												.StoreBranchIosUpdateurl;
											isConnectUrl(wgtUrl);
										})
								} else {
									mui.confirm('检测到有新版本，为了不影响您的正常使用，请更新至新版本', '更新提示', ['暂不更新',
											'立即更新'
										],
										function(e) {
											if (e.index === 1) {
												wgtUrl = baseUrl + updateres.Data
													.StoreBranchIosUpdateurl;
												isConnectUrl(wgtUrl);
											} else {
												sessionStorage.setItem('isUpdate', 'true');

											}
										})
								}
							}
							break;
						default:
							// 其它平台  
							break;
					}


				},
				function(err) {

				});
		});
		// plus.runtime.setProperty(plus.runtime.appid, function(inf) {
		// 	inf.version = '4.2.3';
		// })

		// setTimeout(function() {
		// 	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		// 		curVer = inf.version;
		// 		console.log(inf.version)
		// 	})
		// }, 1000);


	})

}

//判断下载地址是否可用
function isConnectUrl(url, isSilent) {
	console.log('url=' + url)
	mui.ajax(url, {
		dataType: 'json', //服务器返回json格式数据
		type: 'post', //HTTP请求类型
		timeout: 20000, //超时时间设置为10秒；
		headers: {
			'Content-Type': 'application/json'
		},
		success: function(data) {
			//服务器返回响应，根据响应结果，分析是否登录成功；
			console.log("可用");
			downWgt(isSilent);
		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			console.log(JSON.stringify(xhr));
			console.log("不可用")

			if (xhr.status == 404) {
				if (!isSilent) {
					plus.nativeUI.alert(
						"APP更新失败，请您到广东省干部培训网络学院首页右侧点击“网络学院APP”链接，扫码重新安装，或到华为应用市场搜索“广东网院”重新安装");
				}
			} else {
				downWgt(isSilent);
			}
		}
	});
}

/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareVersion(ov, nv) {

	if (!ov || !nv || ov == "" || nv == "") {
		return false;
	}
	var b = false,
		ova = ov.split(".", 4),
		nva = nv.split(".", 4);
	for (var i = 0; i < ova.length && i < nva.length; i++) {
		var so = ova[i],
			no = parseInt(so),
			sn = nva[i],
			nn = parseInt(sn);
		if (nn > no || sn.length > so.length) {
			return true;
		} else if (nn < no) {
			return false;
		}
	}
	if (nva.length > ova.length && 0 == nv.indexOf(ov)) {
		return true;
	}
}



function downWgt(isSilent) {
	if (isSilent) {
		plus.nativeUI.showWaiting("加载中...");
	} else {
		plus.nativeUI.showWaiting("下载更新文件...");
	}
	plus.downloader.createDownload(wgtUrl, {
		filename: "_doc/update/"
	}, function(d, status) {
		if (status == 200) {
			console.log("下载更新文件成功：" + d.filename);
			installWgt(d.filename, isSilent); // 安装wgt包  
		} else {
			console.log("下载更新文件失败！");
			if (!isSilent) {
				plus.nativeUI.alert("APP更新失败，请您到广东省干部培训网络学院首页右侧点击“网络学院APP”链接，扫码重新安装，或到华为应用市场搜索“广东网院”重新安装");
			}
		}

		plus.nativeUI.closeWaiting();
	}).start();
}

// 更新应用资源  
function installWgt(path, isSilent) {
	if (isSilent) {
		plus.nativeUI.showWaiting("加载中...");
	} else {
		plus.nativeUI.showWaiting("安装更新文件...");
	}
	plus.runtime.install(path, {}, function() {
		plus.nativeUI.closeWaiting();
		console.log("安装更新文件成功！");
		if (wgtUrl.search('.wgt') != -1) {
			if (isSilent) {
				if (serverFlagSilent == '0') {
					plus.runtime.restart();
				} else if (serverFlagSilent == '2') {
					mui.alert('检测到有新版本，请点击确定重启App继续使用', '提示',
						'确定',
						function(e) {
							if (e.index == 0) {
								plus.runtime.restart();
							}
						}); //是否需要强制更新大版本
				} else if (serverFlagSilent == '3') {
					plus.nativeUI.confirm("检测到有新版本，请点击确定重启App继续使用", function(e) {
						if (e.index === 0) {
							plus.runtime.restart();
						}
					})
				}
			} else {
				plus.nativeUI.confirm("应用资源更新完成，点击确定重启App以应用本次更新内容", function(e) {
					if (e.index === 0) {
						plus.runtime.restart();
					}
				})
			}
		}
	}, function(e) {
		plus.nativeUI.closeWaiting();
		if (!isSilent) {
			console.log("安装wgt文件失败[" + e.code + "]：" + e.message);
			plus.nativeUI.alert("安装wgt文件失败[" + e.code + "]：" + e.message);
		}
	});
}

function alertUpdata(wgtUrl) {
	mui.alert('检测到有新版本，为了不影响您的正常使用，请更新至新版本', '更新提示',
		function(e) {
			if (e.index === 0) {
				isConnectUrl(wgtUrl);
			} else if (e.index === -1) {
				//安卓物理返回键
				alertUpdata(wgtUrl);
			}
		})
}

function alertUpdataAppstore() {
	mui.alert('检测到有新版本，为了不影响您的正常使用，请前往AppStore更新版本至最新！', '应用更新',
		'确定',
		function() {
			plus.runtime.openURL(
				'itms-apps://itunes.apple.com/app/1620735472'
			)
			alertUpdataAppstore();
		}); //是否需要强制更新大版本

}
